var Register = function()
{
	var register = {};
	var debug = 0;
	
	var aliquots;
	var allNames;
	
	// Page initialization
	register.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', register.validateStep1);
		Events.addEventHandler('workList', 'change', register.worklistOnChange);
		Events.addEventHandler('completedDate', 'change', Wizard.validateDate);
		Events.addEventHandler('outcomeSuccess', 'click', register.outcomeOnChange);
		Events.addEventHandler('outcomeFailed', 'click', register.outcomeOnChange);

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', register.initializeStep2);
		Events.addEventHandler('except', 'change', register.exceptChange);
		Buttons.addClickHandler('btnBrowseExcept', register.browseExcept);
		Events.addEventHandler('btnBrowseExcept', 'base-selected', register.exceptSelected);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', register.submit);
		
		var url = '../Outtake.servlet?ID='+App.getSessionId();
		url += '&cmd=GetOuttakeWorklists';
		Wizard.showLoadingAnimation('Loading outtake work lists...');
		Wizard.asyncJsonRequest(url, register.initializeStep1);
	}

	register.initializeStep1 = function(response)
	{
		var frm = document.forms['reggie'];
		var workLists = response.workLists;
		
		var workList = frm.workList;
		if (workLists.length > 0)
		{
			for (var i=0; i < workLists.length; i++)
			{
				var list = workLists[i];
				var name = list.name + ' (' + list.size + ')';
				var option = new Option(name, list.id);
				option.workList = list;
				workList.options[workList.length] = option;
			}
			Events.sendChangeEvent(workList);
		}
		else
		{
			Wizard.setFatalError('No outtake works lists available for processing.');
			return;
		}
		
		Doc.show('step-1');
		Doc.show('goregister');
	}
	
	register.worklistOnChange = function()
	{
		var frm = document.forms['reggie'];
		var workList = frm.workList[frm.workList.selectedIndex].workList;
		frm.comments.value = workList.comments;
	}

	register.validateStep1 = function(event)
	{
		var frm = document.forms['reggie'];
		var valid = frm.workList.selectedIndex >= 0;
		valid &= Wizard.isValid('completedDate');

		if (!valid)
		{
			event.preventDefault();
		}
	}

	
	register.outcomeOnChange = function()
	{
		var frm = document.forms['reggie'];
		var failed = Doc.element('outcomeFailed').checked
		Doc.showHide('gonext', failed);
		Doc.showHide('goregister', !failed);
	}

	register.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];

		var url = '../Outtake.servlet?ID='+App.getSessionId();
		url += '&cmd=GetOuttakeInfo';
		url += '&workListId='+frm.workList.value;
		Wizard.showLoadingAnimation('Loading aliquot information...');
		Wizard.asyncJsonRequest(url, register.aliquotsLoaded);
	}
	
	register.aliquotsLoaded = function(response)
	{
		aliquots = response.aliquots;
		allNames = [];
		var aliquots = response.aliquots;
		
		for (var aliquotNo = 0; aliquotNo < aliquots.length; aliquotNo++)
		{
			var a = aliquots[aliquotNo];
			var p = a.parent;
			allNames[a.name] = a.id;
			allNames[p.name] = a.id;
		}
		
		Wizard.setCurrentStep(2);
		Doc.show('goregister');
		Doc.show('gocancel');
	}
	
	
	register.exceptChange = function()
	{
		var frm = document.forms['reggie'];
		if (frm.except.length > 0)
		{
			Wizard.setInputStatus('except', 'valid');
		}
		else
		{
			Wizard.setInputStatus('except');
		}
	}
	
	var exceptMessages;
	register.browseExcept = function()
	{
		var frm = document.forms['reggie'];
		var workList = frm.workList[frm.workList.selectedIndex].workList;
		
		var currentExcept = Link.getIdsInList(frm.except, workList.itemType);
		exceptMessages = [];
		Wizard.showFinalMessage(exceptMessages);
		var url = '&resetTemporary=1&exclude='+currentExcept.join(',');
		url += '&tmpfilter:INT:§itemLists='+frm.workList.value;
		Dialogs.selectItem(workList.itemType, 'btnBrowseExcept', 1, url);
	}
	
	
	register.exceptSelected = function(event)
	{
		var frm = document.forms['reggie'];
		
		var item = event.detail;
		if (register.checkItemIsAliquot(item))
		{
			Link.addItem('except', item.itemType, item);
		}
		else
		{
			exceptMessages[exceptMessages.length] = '[Warning]'+Strings.encodeTags(item.name) + ' is not in the selected work list';
		}
		if (item.remaining == 0)
		{
			Events.sendChangeEvent('except');
			Wizard.showFinalMessage(exceptMessages);
		}
	}
	
	register.checkItemIsAliquot = function(item)
	{
		var id = allNames[item.name];
		if (id) item.id = id;
		return id;
	}
	
	register.submit = function()
	{
		var frm = document.forms['reggie'];
		var workList = frm.workList[frm.workList.selectedIndex].workList;

		var submitInfo = {};
		submitInfo.workList = parseInt(frm.workList.value, 10);

		var failed = Doc.element('outcomeFailed').checked;
		submitInfo.failed = failed;
		if (failed)
		{
			submitInfo.sampleConsumed = Doc.element('sampleConsumedYes').checked;
			var except = [];
			submitInfo.except = Link.getIdsInList(frm.except, workList.itemType);
		}
		
		submitInfo.completedDate = frm.completedDate.value;
		submitInfo.comments = frm.comments.value;
		
		var	url = '../Outtake.servlet?ID='+App.getSessionId();
		url += '&cmd=RegisterOuttakeComplete';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, register.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	register.submissionResults = function(response)
	{
		var frm = document.forms['reggie'];
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	return register;
}();

Doc.onLoad(Register.initPage);

