<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~allprep_protocol.js" 
	styles="path.css,~../css/reggie-2.css"
/>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab Tracking Protocol for Allprep isolation" 
		/></p:path>

	<div class="content">

	<form name="reggie" action="allprep_protocol2.jsp" method="post" target="_blank" id="wizard" class="wizard">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="YellowLabel" value="0" id="YellowLabel">
	<input type="hidden" name="AutoProcessing" value="0" id="AutoProcessing">
	
	<!-- 1. Case name-->
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select lysate items</div>
		<div class="step-content">

			<table class="step-form">
			<tr class="align-top" id="regularFlowRow">
				<td class="prompt">Lysates<div style="font-weight: normal;">(regular flow)</div></td>
				<td class="input">
					<select name="lysates" id="lysates" class="yellow-label-support" multiple size="15" data-current-user="<%=HTML.encodeTags(user.getName())%>"></select>
				</td>
				<td class="status" id="lysates.status"></td>
				<td class="help">
					<span id="lysates.message" class="message"></span>
					Select 1-12 items. The list contain Lysate items that has not yet been processed
					(determined by absence of a 'creation' date).<br>
					<base:icon image="<%=home+"/images/yellow-label.png"%>" /> = YellowLabel specimen
				</td>
			</tr>
			<tr class="align-top" id="reExtractionRow" style="display: none;">
				<td class="prompt">Lysates<div style="font-weight: normal;">(re-extraction)</div></td>
				<td class="input">
					<select name="reextraction" id="reextraction" multiple size="12" class="yellow-label-support"></select>
					<base:button id="downloadLabels" title="Download labels..." image="<%=home+"/images/download.png"%>" />
				</td>
				<td class="status" id="reextraction.status"></td>
				<td class="help">
					<span id="reextraction.message" class="message"></span>
					Select lysates that have been marked for re-extraction to include in this extraction.
					Use the <b>Download labels</b> buttons to download a file for creating labels.
				</td>
			</tr>
			<tr>
				<td class="prompt">Reserve selected lysates</td>
				<td class="input">
					<label><input type="checkbox" checked name="reserve" id="reserve" value="0">
					Yes</label>
				</td>
				<td class="status" id="reserve.status"></td>
				<td class="help">
					<span id="reserve.message" class="message"></span>
					If checked, the selected lysates will be marked as reserved by the current user.<br>
					Note that this is an aid only and it will not prevent them from being selected
					by other users.
				</td>
			</tr>
			</table>
		</div>
	</div>
		
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocreate" title="Finish" image="<%=home+"/images/gonext.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>